# ubuntu-drivers-common custom detect plugin for arm GLES drivers
#
# (C) 2012 Canonical Ltd.
# Author: Oliver Grawert <ogra@ubuntu.com>
#
# This plugin detects GLES driver packages based on pattern matching
# against the "Hardware" line in /proc/cpuinfo.
#
# To add a new SoC, simply insert a line into the db variable with the
# following format:
#
# '<Pattern from your cpuinfo output>': '<Name of the driver package>',
#

import logging

db = {'Hardkernel ODROID-C4': 'mali-bifrost-wayland-driver',
      'Hardkernel ODROID-N2': 'mali-bifrost-wayland-driver',
      }


def detect(apt_cache):
    try:
        with open('/proc/device-tree/model') as file:
            line = file.read()
            for pattern in db.keys():
                if pattern in line:
                    return [db[pattern]]
    except IOError as err:
        logging.debug('could not open /proc/device-tree/model: %s', err)

    return None
